// Connect.h : Declaration of the CConnect

#pragma once
#include "resource.h"       // main symbols

// CConnect
class ATL_NO_VTABLE CConnect : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CConnect, &CLSID_Connect>,
	public IDispatchImpl<AddInDesignerObjects::_IDTExtensibility2, &AddInDesignerObjects::IID__IDTExtensibility2, &AddInDesignerObjects::LIBID_AddInDesignerObjects, 1, 0>,
	public IDispEventSimpleImpl<1, CConnect, &__uuidof(Office::_CommandBarButtonEvents)>,
	public IDispEventSimpleImpl<2, CConnect, &__uuidof(Office::_CommandBarButtonEvents)>
{
public:
	CConnect()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)
DECLARE_NOT_AGGREGATABLE(CConnect)

BEGIN_COM_MAP(CConnect)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(AddInDesignerObjects::IDTExtensibility2)
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

public:
	//IDTExtensibility2 implementation:
	STDMETHOD(OnConnection)(IDispatch * Application, AddInDesignerObjects::ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom);
	STDMETHOD(OnDisconnection)(AddInDesignerObjects::ext_DisconnectMode RemoveMode, SAFEARRAY **custom );
	STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom );
	STDMETHOD(OnStartupComplete)(SAFEARRAY **custom );
	STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom );

	BEGIN_SINK_MAP(CConnect)
		SINK_ENTRY_INFO(1, __uuidof(Office::_CommandBarButtonEvents), 1, button_SaveToStream, dscsInfo())
		SINK_ENTRY_INFO(2, __uuidof(Office::_CommandBarButtonEvents), 1, button_PasteFromStream, dscsInfo())
	END_SINK_MAP()	

private:
	void SaveShape(Visio::IVShapePtr shape);
	void DropSavedShape(Visio::IVPagePtr page);

	Office::_CommandBarButtonPtr AddButton(Office::CommandBarPtr cb, LPCWSTR caption, long id);
	void InstallToolbar();

	void __stdcall button_SaveToStream(IDispatch *ctrl, VARIANT_BOOL *CancelDefault);
	void __stdcall button_PasteFromStream(IDispatch *ctrl, VARIANT_BOOL *CancelDefault);

	Office::_CommandBarButtonPtr _buttonSaveToStream;
	Office::_CommandBarButtonPtr _buttonPasteFromStream;

	Visio::IVApplicationPtr _application;
	CComPtr<IDispatch> _addInInstance;

	static _ATL_FUNC_INFO* dscsInfo()
	{
		static struct _ATL_FUNC_INFO _dscsInfo = {CC_STDCALL, VT_EMPTY, 2, {VT_DISPATCH, VT_BOOL|VT_BYREF}};
		return &_dscsInfo;
	}
};
